/* 
 * This file is part of the "Ocapi" project, a C implementation of the
 * OPeNDAP Data Access Protocol.
 *
 * Copyright (c) 2005 OPeNDAP, Inc.
 * Author: John Chamberlain <jchamberlain at opendap.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact OPeNDAP, Inc. at PO Box 112, Saunderstown, RI. 02874-0112.
 */

#define FALSE       0
#define TRUE        1

typedef struct {
    char *sCommand;
    char **asArguments;		/* the command will be arg 0 */
    int ctArguments;
} CommandBuffer;

typedef struct {
    char **asStrings;
    int ctStrings;
} StringList;

int equals(char *s1, char *s2);
char *toUpper(char *s);
int indexOf(char *sBuffer, char *sSearchString);
int indexOf_binary(char *sBuffer, unsigned int lenBuffer,
		   char *sSearchString, unsigned int lenSearchString);
char *sCloneString(const char *s);
CommandBuffer *parseCommand(char *s);
void vFreeCommandBuffer(CommandBuffer * pCB);
StringList *parseQualifiedName(char *s);
char *findError(char *sBuffer);
